import checkers.nullness.quals.*;
import checkers.quals.*;

public class DependentTypes {
    @Dependent(result = Nullable.class, when=Prototype.class) String dep;
    String indep;

    static void fieldAccess() {
        DependentTypes t1 = new DependentTypes();
        t1.dep = null;
        t1.dep = "m";
        t1.indep = null;
        t1.indep = "m";

        @Prototype DependentTypes t2 = new DependentTypes();
        t2.dep = null;
        t2.dep = "m";
        t2.indep = null;
        t2.indep = "m";
    }

    void receiverNonProto() {
        dep = null;
        dep = "m";

        indep = null;
        indep = "m";
    }

    void receiverProto() @Prototype {
        dep = null;
        dep = "m";

        indep = null;
        indep = "m";
    }

    class Parameter {
        Parameter(@Dependent(result = Nullable.class, when = Prototype.class) String param) {
        }
        
        void use() {
            new @Prototype Parameter(null);
            new Parameter(null); // error
            
            new @Prototype Parameter("m");
            new Parameter("m");
        }
    }
    @interface Prototype {}
}
